---
title: TouchEvent
slug: Web/API/TouchEvent
tags:
  - API
  - DOM
  - Interface
  - Reference
  - TouchEvent
  - touch
---
<p>{{APIRef("Touch Events")}}</p>

<p>The <strong><code>TouchEvent</code></strong> interface represents an {{domxref("UIEvent")}} which is sent when the state of contacts with a touch-sensitive surface changes. This surface can be a touch screen or trackpad, for example. The event can describe one or more points of contact with the screen and includes support for detecting movement, addition and removal of contact points, and so forth.</p>

<p>Touches are represented by the {{domxref("Touch")}} object; each touch is described by a position, size and shape, amount of pressure, and target element. Lists of touches are represented by {{domxref("TouchList")}} objects.</p>

<p>{{InheritanceDiagram}}</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("TouchEvent.TouchEvent", "TouchEvent()")}}</dt>
 <dd>Creates a <code>TouchEvent</code> object.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>This interface inherits properties from its parent, {{domxref("UIEvent")}} and {{domxref("Event")}}.</em></p>

<dl>
 <dt>{{domxref("TouchEvent.altKey")}} {{readonlyInline}}</dt>
 <dd>A Boolean value indicating whether or not the alt key was down when the touch event was fired.</dd>
 <dt>{{domxref("TouchEvent.changedTouches")}} {{readonlyInline}}</dt>
 <dd>A {{domxref("TouchList")}} of all the {{domxref("Touch")}} objects representing individual points of contact whose states changed between the previous touch event and this one.</dd>
 <dt>{{domxref("TouchEvent.ctrlKey")}} {{readonlyInline}}</dt>
 <dd>A Boolean value indicating whether or not the control key was down when the touch event was fired.</dd>
 <dt>{{domxref("TouchEvent.metaKey")}} {{readonlyInline}}</dt>
 <dd>A Boolean value indicating whether or not the meta key was down when the touch event was fired.</dd>
 <dt>{{domxref("TouchEvent.shiftKey")}} {{readonlyInline}}</dt>
 <dd>A Boolean value indicating whether or not the shift key was down when the touch event was fired.</dd>
 <dt>{{domxref("TouchEvent.targetTouches")}}{{readonlyInline}}</dt>
 <dd>A {{domxref("TouchList")}} of all the {{domxref("Touch")}} objects that are both currently in contact with the touch surface <strong>and</strong> were also started on the same element that is the target of the event.</dd>
 <dt>{{domxref("TouchEvent.touches")}} {{readonlyInline}}</dt>
 <dd>A {{domxref("TouchList")}} of all the {{domxref("Touch")}} objects representing all current points of contact with the surface, regardless of target or changed status.</dd>
 <dt>{{domxref("TouchEvent.rotation")}} {{non-standard_inline()}} {{readonlyInline}}</dt>
 <dd>Change in rotation (in degrees) since the event's beginning. Positive values indicate clockwise rotation; negative values indicate anticlockwise rotation. Initial value: <code>0.0</code></dd>
 <dt>{{domxref("TouchEvent.scale")}} {{non-standard_inline()}} {{readonlyInline}}</dt>
 <dd>Distance between two digits since the event's beginning. Expressed as a floating-point multiple of the initial distance between the digits at the beginning of the event. Values below 1.0 indicate an inward pinch (zoom out). Values above 1.0 indicate an outward unpinch (zoom in). Initial value: <code>1.0</code></dd>
</dl>

<h2 id="Touch_event_types">Touch event types</h2>

<p>There are several types of event that can be fired to indicate that touch-related changes have occurred. You can determine which of these has happened by looking at the event's {{domxref("event.type", "TouchEvent.type")}} property.</p>

<h3 id="touchstart_event">{{domxref("Element/touchstart_event", "touchstart")}}</h3>

<p>Sent when the user places a touch point on the touch surface. The event's target will be the {{domxref("element")}} in which the touch occurred.</p>

<h3 id="touchend_event">{{domxref("Element/touchend_event", "touchend")}}</h3>

<p>Sent when the user removes a touch point from the surface (that is, when they lift a finger or stylus from the surface). This is also sent if the touch point moves off the edge of the surface; for example, if the user's finger slides off the edge of the screen.</p>

<p>The event's target is the same {{domxref("element")}} that received the <code>touchstart</code> event corresponding to the touch point, even if the touch point has moved outside that element.</p>

<p>The touch point (or points) that were removed from the surface can be found in the {{domxref("TouchList")}} specified by the <code>changedTouches</code> attribute.</p>

<h3 id="touchmove_event">{{domxref("Element/touchmove_event", "touchmove")}}</h3>

<p>Sent when the user moves a touch point along the surface. The event's target is the same {{domxref("element")}} that received the <code>touchstart</code> event corresponding to the touch point, even if the touch point has moved outside that element.</p>

<p>This event is also sent if the values of the radius, rotation angle, or force attributes of a touch point change.</p>

<div class="note"><strong>Note:</strong> The rate at which <code>touchmove</code> events is sent is browser-specific, and may also vary depending on the capability of the user's hardware. You must not rely on a specific granularity of these events.</div>

<h3 id="touchcancel_event">{{domxref("Element/touchcancel_event", "touchcancel")}}</h3>

<p>Sent when a touch point has been disrupted in some way. There are several possible reasons why this might happen (and the exact reasons will vary from device to device, as well as browser to browser):</p>

<ul>
 <li>An event of some kind occurred that canceled the touch; this might happen if a modal alert pops up during the interaction.</li>
 <li>The touch point has left the document window and moved into the browser's UI area, a plug-in, or other external content.</li>
 <li>The user has placed more touch points on the screen than can be supported, in which case the earliest {{domxref("Touch")}} in the {{domxref("TouchList")}} gets canceled.</li>
</ul>

<h3 id="Using_with_addEventListener_and_preventDefault">Using with addEventListener() and preventDefault()</h3>

<p>It's important to note that in many cases, both touch and mouse events get sent (in order to let non-touch-specific code still interact with the user). If you use touch events, you should call {{domxref("Event.preventDefault","preventDefault()")}} to keep the mouse event from being sent as well.</p>

<p>The exception to this is Chrome, starting with version 56 (desktop, Chrome for android, and android webview), where the default value for the <code>passive</code> option for {{domxref("Element/touchstart_event", "touchstart")}} and {{domxref("Element/touchmove_event", "touchmove")}} is <code>true</code> and calls to {{domxref("Event.preventDefault","preventDefault()")}} will have no effect. To override this behavior, you need to set the <code>passive</code> option to <code>false</code>, after which calling {{domxref("Event.preventDefault","preventDefault()")}} will work as specified. The change to treat listeners as <code>passive</code> by default prevents the listener from blocking page rendering while a user is scrolling. A demo is available on the <a href="https://developers.google.com/web/updates/2016/06/passive-event-listeners">Google Developer</a> site.</p>

<h2 id="GlobalEventHandlers">GlobalEventHandlers</h2>

<p>The {{domxref("GlobalEventHandlers")}} mixin defines these events as global events that are available on any element in the DOM that the user can interact with.</p>

<dl>
 <dt>{{domxref("GlobalEventHandlers.ontouchstart")}} {{experimental_inline}}</dt>
 <dd>A {{domxref("GlobalEventHandlers","global event handler", "", 1)}} for the {{domxref("Element/touchstart_event", "touchstart")}} event.</dd>
 <dt>{{domxref("GlobalEventHandlers.ontouchend")}} {{experimental_inline}}</dt>
 <dd>A {{domxref("GlobalEventHandlers","global event handler", "", 1)}} for the {{domxref("Element/touchend_event", "touchend")}} event.</dd>
 <dt>{{domxref("GlobalEventHandlers.ontouchmove")}} {{experimental_inline}}</dt>
 <dd>A {{domxref("GlobalEventHandlers","global event handler", "", 1)}} for the {{domxref("Element/touchmove_event", "touchmove")}} event.</dd>
 <dt>{{domxref("GlobalEventHandlers.ontouchcancel")}} {{experimental_inline}}</dt>
 <dd>A {{domxref("GlobalEventHandlers","global event handler", "", 1)}} for the {{domxref("Element/touchcancel_event", "touchcancel")}} event.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>See the <a href="/en-US/docs/Web/API/Touch_events#Example">example on the main Touch events article</a>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Touch Events 2','#touchevent-interface', 'TouchEvent')}}</td>
   <td>{{Spec2('Touch Events 2')}}</td>
   <td>Added <code>ontouchstart</code>, <code>ontouchend</code>, <code>ontouchmove</code>, <code>ontouchend</code> global attribute handlers</td>
  </tr>
  <tr>
   <td>{{SpecName('Touch Events', '#touchevent-interface', 'TouchEvent')}}</td>
   <td>{{Spec2('Touch Events')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.TouchEvent")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Touch_events">Touch events</a></li>
 <li>{{domxref("GestureEvent")}}</li>
 <li>{{domxref("MSGestureEvent")}}</li>
</ul>
